\section{Request Parameters\label{sec:http:params}}

Part of the URL is the Query String. This is a string of keys and
corresponding values. For \GET requests, it's appended to the end of the path, after a
\texttt{?}, and for \POST requests it's part of the request body.

\lstinputlisting[caption=Show a Request Parameter (HTTPRequestParams).]{FunctionalWebExamples/Source/HTTP/RequestParams.hs}

This is similar to the \hyperref[sec:http:headers]{HTTP Headers}
example. In this case, the \Literal{rqParam} function returns a list
of all values provided for a parameter, and not just the first. The
\Literal{writeHellos} function handles this with the
\href{https://hackage.haskell.org/package/bytestring-0.10.6.0/docs/Data-ByteString.html#v:intercalate}{\Literal{intercalate}}
function from the
\href{https://hackage.haskell.org/package/bytestring-0.10.6.0}{\Literal{bytestring}}
package.

\lstinputlisting[linerange=14-15,firstnumber=14,caption=Intercalating all the ``hello'' values.]{FunctionalWebExamples/Source/HTTP/RequestParams.hs}

\subsection{Exercises}

\begin{Exercise}[difficulty=1,title=Show a different parameter.]
Show a parameter with a different name.
\end{Exercise}

\begin{Exercise}[difficulty=2,title=Show more than one parameter.]
Show both the \textit{hello} parameter and an additional parameter if present.
\end{Exercise}

%%% Local Variables:
%%% mode: latex
%%% TeX-master: "../../FunctionalWeb"
%%% End:
